source: installer/opengnsys_update.sh @ 8601c62

918-git-images-111dconfigfileconfigure-oglivegit-imageslgromero-new-oglivemainmaint-cronmount-efivarfsmultivmmultivm-ogboot-installerogClonningEngineogboot-installer-jenkinsoglive-ipv6test-python-scriptsticket-301ticket-50ticket-50-oldticket-577ticket-585ticket-611ticket-612ticket-693ticket-700ubu24tplunification2use-local-agent-oglivevarios-instalacionwebconsole3
Last change on this file since 8601c62 was 2f9cd767, checked in by ramon <ramongomez@…>, 8 years ago

#768: Corregir errata en revisión r5199.

git-svn-id: https://opengnsys.es/svn/branches/version1.1@5201 a21b9725-9963-47de-94b9-378ad31fedc9

  • Property mode set to 100755
File size: 35.1 KB
Line 
1#!/bin/bash
2#/**
3#@file    opengnsys_update.sh
4#@brief   Script actualización de OpenGnsys
5#@version 0.9 - basado en opengnsys_installer.sh
6#@author  Ramón Gómez - ETSII Univ. Sevilla
7#@date    2010/01/27
8#@version 1.0 - adaptación a OpenGnSys 1.0
9#@author  Ramón Gómez - ETSII Univ. Sevilla
10#@date    2011/03/02
11#@version 1.0.1 - control de auto actualización del script
12#@author  Ramón Gómez - ETSII Univ. Sevilla
13#@date    2011/05/17
14#@version 1.0.2a - obtiene valor de dirección IP por defecto
15#@author  Ramón Gómez - ETSII Univ. Sevilla
16#@date    2012/01/18
17#@version 1.0.3 - Compatibilidad con Debian y auto configuración de acceso a BD.
18#@author  Ramón Gómez - ETSII Univ. Sevilla
19#@date    2012/03/12
20#@version 1.0.4 - Detector de distribución y compatibilidad con CentOS.
21#@author  Ramón Gómez - ETSII Univ. Sevilla
22#@date    2012/05/04
23#@version 1.0.5 - Actualizar BD en la misma versión, compatibilidad con Fedora (systemd) y configuración de Rsync.
24#@author  Ramón Gómez - ETSII Univ. Sevilla
25#@date    2014/04/03
26#@version 1.0.6 - Redefinir URLs de ficheros de configuración usando HTTPS.
27#@author  Ramón Gómez - ETSII Univ. Sevilla
28#@date    2015/03/12
29#@version 1.1.0 - Instalación de API REST y configuración de zona horaria.
30#@author  Ramón Gómez - ETSII Univ. Sevilla
31#@date    2015/11/09
32#*/
33
34
35####  AVISO: NO EDITAR variables de configuración.
36####  WARNING: DO NOT EDIT configuration variables.
37INSTALL_TARGET=/opt/opengnsys           # Directorio de instalación
38OPENGNSYS_CLIENTUSER="opengnsys"        # Usuario Samba
39
40
41# Sólo ejecutable por usuario root
42if [ "$(whoami)" != 'root' ]; then
43        echo "ERROR: this program must run under root privileges!!"
44        exit 1
45fi
46# Error si OpenGnsys no está instalado (no existe el directorio del proyecto)
47if [ ! -d $INSTALL_TARGET ]; then
48        echo "ERROR: OpenGnsys is not installed, cannot update!!"
49        exit 1
50fi
51# Cargar configuración de acceso a la base de datos.
52if [ -r $INSTALL_TARGET/etc/ogAdmServer.cfg ]; then
53        source $INSTALL_TARGET/etc/ogAdmServer.cfg
54elif [ -r $INSTALL_TARGET/etc/ogAdmAgent.cfg ]; then
55        source $INSTALL_TARGET/etc/ogAdmAgent.cfg
56fi
57OPENGNSYS_DATABASE=${OPENGNSYS_DATABASE:-"$CATALOG"}            # Base de datos
58OPENGNSYS_DBUSER=${OPENGNSYS_DBUSER:-"$USUARIO"}                # Usuario de acceso
59OPENGNSYS_DBPASSWORD=${OPENGNSYS_DBPASSWORD:-"$PASSWORD"}       # Clave del usuario
60if [ -z "$OPENGNSYS_DATABASE" -o -z "$OPENGNSYS_DBUSER" -o -z "$OPENGNSYS_DBPASSWORD" ]; then
61        echo "ERROR: set OPENGNSYS_DATABASE, OPENGNSYS_DBUSER and OPENGNSYS_DBPASSWORD"
62        echo "       variables, and run this script again."
63fi
64
65# Comprobar si se ha descargado el paquete comprimido (USESVN=0) o sólo el instalador (USESVN=1).
66PROGRAMDIR=$(readlink -e $(dirname "$0"))
67PROGRAMNAME=$(basename "$0")
68OPENGNSYS_SERVER="www.opengnsys.es"
69if [ -d "$PROGRAMDIR/../installer" ]; then
70        USESVN=0
71else
72        USESVN=1
73fi
74SVN_URL="http://$OPENGNSYS_SERVER/svn/branches/version1.1/"
75
76WORKDIR=/tmp/opengnsys_update
77mkdir -p $WORKDIR
78
79# Registro de incidencias.
80OGLOGFILE=$INSTALL_TARGET/log/${PROGRAMNAME%.sh}.log
81LOG_FILE=/tmp/$(basename $OGLOGFILE)
82
83
84
85#####################################################################
86####### Algunas funciones útiles de propósito general:
87#####################################################################
88
89# Generar variables de configuración del actualizador
90# Variables globales:
91# - OSDISTRIB - distribución Linux
92# - DEPENDENCIES - array de dependencias que deben estar instaladas
93# - UPDATEPKGLIST, INSTALLPKGS, CHECKPKG - comandos para gestión de paquetes
94# - APACHECFGDIR, APACHESERV, DHCPSERV, INETDCFGDIR - configuración y servicios
95function autoConfigure()
96{
97local i
98
99# Detectar sistema operativo del servidor (compatible con fichero os-release y con LSB).
100if [ -f /etc/os-release ]; then
101        source /etc/os-release
102        OSDISTRIB="$ID"
103        OSVERSION="$VERSION_ID"
104else
105        OSDISTRIB=$(lsb_release -is 2>/dev/null)
106        OSVERSION=$(lsb_release -rs 2>/dev/null)
107fi
108# Convertir distribución a minúsculas y obtener solo el 1er número de versión.
109OSDISTRIB="${OSDISTRIB,,}"
110OSVERSION="${OSVERSION%%.*}"
111
112# Configuración según la distribución de Linux.
113case "$OSDISTRIB" in
114        ubuntu|debian|linuxmint)
115                DEPENDENCIES=( php5-ldap xinetd rsync btrfs-tools procps arp-scan realpath php5-curl gettext moreutils jq )
116                UPDATEPKGLIST="apt-get update"
117                INSTALLPKGS="apt-get -y install --force-yes"
118                CHECKPKG="dpkg -s \$package 2>/dev/null | grep -q \"Status: install ok\""
119                if which service &>/dev/null; then
120                        STARTSERVICE="eval service \$service restart"
121                        STOPSERVICE="eval service \$service stop"
122                else
123                        STARTSERVICE="eval /etc/init.d/\$service restart"
124                        STOPSERVICE="eval /etc/init.d/\$service stop"
125                fi
126                ENABLESERVICE="eval update-rc.d \$service defaults"
127                APACHEUSER="www-data"
128                APACHEGROUP="www-data"
129                INETDCFGDIR=/etc/xinetd.d
130                ;;
131        fedora|centos)
132                DEPENDENCIES=( php-ldap xinetd rsync btrfs-progs procps-ng arp-scan gettext moreutils jq )
133                # En CentOS 7 instalar arp-scan de CentOS 6.
134                [ "$OSDISTRIB$OSVERSION" == "centos7" ] && DEPENDENCIES=( ${DEPENDENCIES[*]/arp-scan/http://dag.wieers.com/redhat/el6/en/$(arch)/dag/RPMS/arp-scan-1.9-1.el6.rf.$(arch).rpm} )
135                INSTALLPKGS="yum install -y"
136                CHECKPKG="rpm -q --quiet \$package"
137                if which systemctl &>/dev/null; then
138                        STARTSERVICE="eval systemctl start \$service.service"
139                        STOPSERVICE="eval systemctl stop \$service.service"
140                        ENABLESERVICE="eval systemctl enable \$service.service"
141                else
142                        STARTSERVICE="eval service \$service start"
143                        STOPSERVICE="eval service \$service stop"
144                        ENABLESERVICE="eval chkconfig \$service on"
145                fi
146                APACHEUSER="apache"
147                APACHEGROUP="apache"
148                INETDCFGDIR=/etc/xinetd.d
149                ;;
150        *)      # Otras distribuciones.
151                ;;
152esac
153for i in apache2 httpd; do
154        [ -f /etc/$i ] && APACHECFGDIR="/etc/$i"
155        [ -f /etc/init.d/$i ] && APACHESERV="/etc/init.d/$i"
156done
157for i in dhcpd dhcpd3-server isc-dhcp-server; do
158        [ -f /etc/init.d/$i ] && DHCPSERV="/etc/init.d/$i"
159done
160}
161
162
163# Comprobar auto-actualización.
164function checkAutoUpdate()
165{
166        local update=0
167
168        # Actaulizar el script si ha cambiado o no existe el original.
169        if [ $USESVN -eq 1 ]; then
170                svn export $SVN_URL/installer/$PROGRAMNAME
171                if ! diff -q $PROGRAMNAME $INSTALL_TARGET/lib/$PROGRAMNAME 2>/dev/null || ! test -f $INSTALL_TARGET/lib/$PROGRAMNAME; then
172                        mv $PROGRAMNAME $INSTALL_TARGET/lib
173                        update=1
174                else
175                        rm -f $PROGRAMNAME
176                fi
177        else
178                if ! diff -q $PROGRAMDIR/$PROGRAMNAME $INSTALL_TARGET/lib/$PROGRAMNAME 2>/dev/null || ! test -f $INSTALL_TARGET/lib/$PROGRAMNAME; then
179                        cp -a $PROGRAMDIR/$PROGRAMNAME $INSTALL_TARGET/lib
180                        update=1
181                fi
182        fi
183
184        return $update
185}
186
187
188function getDateTime()
189{
190        date "+%Y%m%d-%H%M%S"
191}
192
193# Escribe a fichero y muestra por pantalla
194function echoAndLog()
195{
196        echo $1
197        DATETIME=`getDateTime`
198        echo "$DATETIME;$SSH_CLIENT;$1" >> $LOG_FILE
199}
200
201function errorAndLog()
202{
203        echo "ERROR: $1"
204        DATETIME=`getDateTime`
205        echo "$DATETIME;$SSH_CLIENT;ERROR: $1" >> $LOG_FILE
206}
207
208# Escribe a fichero y muestra mensaje de aviso
209function warningAndLog()
210{
211        local DATETIME=`getDateTime`
212        echo "Warning: $1"
213        echo "$DATETIME;$SSH_CLIENT;Warning: $1" >> $LOG_FILE
214}
215
216
217#####################################################################
218####### Funciones de copia de seguridad y restauración de ficheros
219#####################################################################
220
221# Hace un backup del fichero pasado por parámetro
222# deja un -last y uno para el día
223function backupFile()
224{
225        if [ $# -ne 1 ]; then
226                errorAndLog "${FUNCNAME}(): invalid number of parameters"
227                exit 1
228        fi
229
230        local fichero=$1
231        local fecha=`date +%Y%m%d`
232
233        if [ ! -f $fichero ]; then
234                warningAndLog "${FUNCNAME}(): file $fichero doesn't exists"
235                return 1
236        fi
237
238        echoAndLog "${FUNCNAME}(): Making $fichero back-up"
239
240        # realiza una copia de la última configuración como last
241        cp -a $fichero "${fichero}-LAST"
242
243        # si para el día no hay backup lo hace, sino no
244        if [ ! -f "${fichero}-${fecha}" ]; then
245                cp -a $fichero "${fichero}-${fecha}"
246        fi
247}
248
249# Restaura un fichero desde su copia de seguridad
250function restoreFile()
251{
252        if [ $# -ne 1 ]; then
253                errorAndLog "${FUNCNAME}(): invalid number of parameters"
254                exit 1
255        fi
256
257        local fichero=$1
258
259        echoAndLog "${FUNCNAME}(): restoring file $fichero"
260        if [ -f "${fichero}-LAST" ]; then
261                cp -a "$fichero-LAST" "$fichero"
262        fi
263}
264
265
266#####################################################################
267####### Funciones de acceso a base de datos
268#####################################################################
269
270# Actualizar la base datos
271function importSqlFile()
272{
273        if [ $# -ne 4 ]; then
274                errorAndLog "${FNCNAME}(): invalid number of parameters"
275                exit 1
276        fi
277
278        local dbuser="$1"
279        local dbpassword="$2"
280        local database="$3"
281        local sqlfile="$4"
282        local tmpfile=$(mktemp)
283        local mycnf=/tmp/.my.cnf.$$
284        local status
285        local APIKEY=$(php -r 'echo md5(uniqid(rand(), true));')
286        REPOKEY=$(php -r 'echo md5(uniqid(rand(), true));')
287
288        if [ ! -r $sqlfile ]; then
289                errorAndLog "${FUNCNAME}(): Unable to read $sqlfile!!"
290                return 1
291        fi
292
293        echoAndLog "${FUNCNAME}(): importing SQL file to ${database}..."
294        chmod 600 $tmpfile
295        sed -e "s/SERVERIP/$SERVERIP/g" -e "s/DBUSER/$OPENGNSYS_DB_USER/g" \
296            -e "s/DBPASSWORD/$OPENGNSYS_DB_PASSWD/g" \
297            -e "s/APIKEY/$APIKEY/g" -e "s/REPOKEY/$REPOKEY/g" $sqlfile > $tmpfile
298        # Componer fichero con credenciales de conexión. 
299        touch $mycnf
300        chmod 600 $mycnf
301        cat << EOT > $mycnf
302[client]
303user=$dbuser
304password=$dbpassword
305EOT
306        # Ejecutar actualización y borrar fichero de credenciales.
307        mysql --defaults-extra-file=$mycnf --default-character-set=utf8 -D "$database" < $tmpfile
308        status=$?
309        rm -f $mycnf $tmpfile
310        if [ $status -ne 0 ]; then
311                errorAndLog "${FUNCNAME}(): error importing $sqlfile in database $database"
312                return 1
313        fi
314        echoAndLog "${FUNCNAME}(): file imported to database $database"
315        return 0
316}
317
318
319#####################################################################
320####### Funciones de instalación de paquetes
321#####################################################################
322
323# Instalar las deependencias necesarias para el actualizador.
324function installDependencies()
325{
326        local package
327
328        if [ $# = 0 ]; then
329                echoAndLog "${FUNCNAME}(): no deps needed."
330        else
331                PHP5VERSION=$(apt-cache pkgnames php5 2>/dev/null | sort | head -1)
332                while [ $# -gt 0 ]; do
333                        package="${1/php5/$PHP5VERSION}"
334                        eval $CHECKPKG || INSTALLDEPS="$INSTALLDEPS $package"
335                        shift
336                done
337                if [ -n "$INSTALLDEPS" ]; then
338                        $UPDATEPKGLIST
339                        $INSTALLPKGS $INSTALLDEPS
340                        if [ $? -ne 0 ]; then
341                                errorAndLog "${FUNCNAME}(): cannot install some dependencies: $INSTALLDEPS."
342                                return 1
343                        fi
344                fi
345        fi
346}
347
348
349#####################################################################
350####### Funciones para el manejo de Subversion
351#####################################################################
352
353function svnExportCode()
354{
355        if [ $# -ne 1 ]; then
356                errorAndLog "${FUNCNAME}(): invalid number of parameters"
357                exit 1
358        fi
359
360        local url="$1"
361
362        echoAndLog "${FUNCNAME}(): downloading subversion code..."
363
364        svn checkout "${url}" opengnsys
365        if [ $? -ne 0 ]; then
366                errorAndLog "${FUNCNAME}(): error getting code from ${url}, verify your user and password"
367                return 1
368        fi
369        echoAndLog "${FUNCNAME}(): subversion code downloaded"
370        return 0
371}
372
373
374############################################################
375###  Detectar red
376############################################################
377
378# Comprobar si existe conexión.
379function checkNetworkConnection()
380{
381        OPENGNSYS_SERVER=${OPENGNSYS_SERVER:-"www.opengnsys.es"}
382        wget --spider -q $OPENGNSYS_SERVER
383}
384
385# Obtener los parámetros de red del servidor.
386function getNetworkSettings()
387{
388        # Variables globales definidas:
389        # - SERVERIP:   IP local de la interfaz por defecto.
390
391        local DEVICES
392        local dev
393
394        echoAndLog "${FUNCNAME}(): Detecting network parameters."
395        SERVERIP="$ServidorAdm"
396        DEVICES="$(ip -o link show up | awk '!/loopback/ {sub(/:.*/,"",$2); print $2}')"
397        for dev in $DEVICES; do
398                [ -z "$SERVERIP" ] && SERVERIP=$(ip -o addr show dev $dev | awk '$3~/inet$/ {sub (/\/.*/, ""); print ($4)}')
399        done
400}
401
402
403#####################################################################
404####### Funciones específicas de la instalación de Opengnsys
405#####################################################################
406
407# Actualizar cliente OpenGnsys.
408function updateClientFiles()
409{
410        local ENGINECFG=$INSTALL_TARGET/client/etc/engine.cfg
411
412        # Actualizar ficheros del cliente.
413        backupFile $ENGINECFG
414        echoAndLog "${FUNCNAME}(): Updating OpenGnsys Client files."
415        rsync --exclude .svn -irplt $WORKDIR/opengnsys/client/shared/* $INSTALL_TARGET/client
416        if [ $? -ne 0 ]; then
417                errorAndLog "${FUNCNAME}(): error while updating client structure"
418                exit 1
419        fi
420        find $INSTALL_TARGET/client -name .svn -type d -exec rm -fr {} \; 2>/dev/null
421
422        # Actualizar librerías del motor de clonación.
423        echoAndLog "${FUNCNAME}(): Updating OpenGnsys Cloning Engine files."
424        rsync --exclude .svn -irplt $WORKDIR/opengnsys/client/engine/*.lib* $INSTALL_TARGET/client/lib/engine/bin
425        if [ $? -ne 0 ]; then
426                errorAndLog "${FUNCNAME}(): error while updating engine files"
427                exit 1
428        fi
429        # Actualizar fichero de configuración del motor de clonación.
430        if ! grep -q "^TZ" $ENGINECFG; then
431                TZ=$(timedatectl status | awk -F"[:()]" '/Time.*zone/ {print $2}')
432                cat << EOT >> $ENGINECFG
433# OpenGnsys Server timezone.
434TZ="${TZ// /}"
435EOT
436        fi
437        if ! diff -q ${ENGINECFG}{,-LAST} &>/dev/null; then
438                NEWFILES="$NEWFILES $ENGINECFG"
439        else
440                rm -f ${ENGINECFG}-LAST
441        fi
442
443        echoAndLog "${FUNCNAME}(): client files update success."
444}
445
446# Configurar HTTPS y exportar usuario y grupo del servicio Apache.
447function apacheConfiguration ()
448{
449        # Activar HTTPS (solo actualizando desde versiones anteriores a 1.0.2) y
450        #    activar módulo Rewrite (solo actualizaciones desde 1.0.x a 1.1.x).
451        if [ -e $APACHECFGDIR/sites-available/opengnsys.conf ]; then
452                echoAndLog "${FUNCNAME}(): Configuring Apache modules."
453                mv $APACHECFGDIR/sites-available/opengnsys.conf $APACHECFGDIR/sites-available/opengnsys
454                a2ensite default-ssl
455                a2enmod ssl
456                a2enmod rewrite
457                a2dissite opengnsys.conf
458                a2ensite opengnsys
459        elif [ -e $APACHECFGDIR/conf.modules.d ]; then
460                echoAndLog "${FUNCNAME}(): Configuring Apache modules."
461                sed -i '/rewrite/s/^#//' $APACHECFGDIR/*.conf
462        fi
463
464        # Actualizar configuración para acceso a API REST
465        #    (solo actualizaciones de 1.0.x a 1.1.x).
466        for config in $APACHECFGDIR/{,sites-available/}opengnsys.conf ]; do
467                if [ -e $config ] && ! grep -q "/rest" $config; then
468                        cat << EOT >> $config
469<Directory $INSTALL_TARGET/www/rest>
470        RewriteEngine On
471        RewriteBase /opengnsys/rest/
472        RewriteCond %{REQUEST_FILENAME} !-f
473        RewriteRule ^ index.php [QSA,L]
474</Directory>
475EOT
476                fi
477        done
478
479        # Reiniciar Apache.
480        $APACHESERV restart
481
482        # Variables de ejecución de Apache.
483        # - APACHE_RUN_USER
484        # - APACHE_RUN_GROUP
485        if [ -f $APACHECFGDIR/envvars ]; then
486                source $APACHECFGDIR/envvars
487        fi
488        APACHE_RUN_USER=${APACHE_RUN_USER:-"$APACHEUSER"}
489        APACHE_RUN_GROUP=${APACHE_RUN_GROUP:-"$APACHEGROUP"}
490}
491
492# Configurar servicio Rsync.
493function rsyncConfigure()
494{
495        local service
496
497        # Configurar acceso a Rsync.
498        if [ ! -f /etc/rsyncd.conf ]; then
499                echoAndLog "${FUNCNAME}(): Configuring Rsync service."
500                NEWFILES="$NEWFILES /etc/rsyncd.conf"
501                sed -e "s/CLIENTUSER/$OPENGNSYS_CLIENTUSER/g" \
502                    $WORKDIR/opengnsys/repoman/etc/rsyncd.conf.tmpl > /etc/rsyncd.conf
503                # Habilitar Rsync.
504                if [ -f /etc/default/rsync ]; then
505                        perl -pi -e 's/RSYNC_ENABLE=.*/RSYNC_ENABLE=inetd/' /etc/default/rsync
506                fi
507                if [ -f $INETDCFGDIR/rsync ]; then
508                        perl -pi -e 's/disable.*/disable = no/' $INETDCFGDIR/rsync
509                else
510                        cat << EOT > $INETDCFGDIR/rsync
511service rsync
512{
513        disable = no
514        socket_type = stream
515        wait = no
516        user = root
517        server = $(which rsync)
518        server_args = --daemon
519        log_on_failure += USERID
520        flags = IPv6
521}
522EOT
523                fi
524                # Activar e iniciar Rsync.
525                service="rsync"  $ENABLESERVICE
526                service="xinetd"
527                $ENABLESERVICE; $STARTSERVICE
528        fi
529}
530
531# Copiar ficheros del OpenGnsys Web Console.
532function updateWebFiles()
533{
534        local ERRCODE COMPATDIR f
535
536        echoAndLog "${FUNCNAME}(): Updating web files..."
537
538        # Copiar los ficheros nuevos conservando el archivo de configuración de acceso.
539        backupFile $INSTALL_TARGET/www/controlacceso.php
540        mv $INSTALL_TARGET/www $INSTALL_TARGET/WebConsole
541        rsync --exclude .svn -irplt $WORKDIR/opengnsys/admin/WebConsole $INSTALL_TARGET
542        ERRCODE=$?
543        mv $INSTALL_TARGET/WebConsole $INSTALL_TARGET/www
544        unzip -o $WORKDIR/opengnsys/admin/xajax_0.5_standard.zip -d $INSTALL_TARGET/www/xajax
545        unzip -o $WORKDIR/opengnsys/admin/slim-2.6.1.zip -d $INSTALL_TARGET/www/rest
546        unzip -o $WORKDIR/opengnsys/admin/swagger-ui-2.2.5.zip -d $INSTALL_TARGET/www/rest
547        if [ $ERRCODE != 0 ]; then
548                errorAndLog "${FUNCNAME}(): Error updating web files."
549                exit 1
550        fi
551        restoreFile $INSTALL_TARGET/www/controlacceso.php
552
553        # Cambiar acceso a protocolo HTTPS.
554        if grep -q "http://" $INSTALL_TARGET/www/controlacceso.php 2>/dev/null; then
555                echoAndLog "${FUNCNAME}(): updating web access file"
556                perl -pi -e 's!http://!https://!g' $INSTALL_TARGET/www/controlacceso.php
557                NEWFILES="$NEWFILES $INSTALL_TARGET/www/controlacceso.php"
558        fi
559
560        # Compatibilidad con dispositivos móviles.
561        COMPATDIR="$INSTALL_TARGET/www/principal"
562        for f in acciones administracion aula aulas hardwares imagenes menus repositorios softwares; do
563                sed 's/clickcontextualnodo/clicksupnodo/g' $COMPATDIR/$f.php > $COMPATDIR/$f.device.php
564        done
565        cp -a $COMPATDIR/imagenes.device.php $COMPATDIR/imagenes.device4.php
566
567        # Cambiar permisos para ficheros especiales.
568        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/www/images/{fotos,iconos}
569        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/www/tmp/
570        # Fichero de logs del agente OGAgent.
571        touch $INSTALL_TARGET/log/ogagent.log
572        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/log/ogagent.log
573
574        echoAndLog "${FUNCNAME}(): Web files updated successfully."
575}
576
577# Copiar carpeta de Interface
578function updateInterfaceAdm()
579{
580        local errcode=0
581
582        # Crear carpeta y copiar Interface
583        echoAndLog "${FUNCNAME}(): Copying Administration Interface Folder"
584        mv $INSTALL_TARGET/client/interfaceAdm $INSTALL_TARGET/client/Interface
585        rsync --exclude .svn -irplt $WORKDIR/opengnsys/admin/Interface $INSTALL_TARGET/client
586        errcoce=$?
587        mv $INSTALL_TARGET/client/Interface $INSTALL_TARGET/client/interfaceAdm
588        if [ $errcode -ne 0 ]; then
589                echoAndLog "${FUNCNAME}(): error while updating admin interface"
590                exit 1
591        fi
592        chmod -R +x $INSTALL_TARGET/client/interfaceAdm
593        chown $OPENGNSYS_CLIENTUSER:$OPENGNSYS_CLIENTUSER $INSTALL_TARGET/client/interfaceAdm/CambiarAcceso
594        chmod 700 $INSTALL_TARGET/client/interfaceAdm/CambiarAcceso
595        echoAndLog "${FUNCNAME}(): Admin interface updated successfully."
596}
597
598# Crear documentación Doxygen para la consola web.
599function makeDoxygenFiles()
600{
601        echoAndLog "${FUNCNAME}(): Making Doxygen web files..."
602        $WORKDIR/opengnsys/installer/ogGenerateDoc.sh \
603                        $WORKDIR/opengnsys/client/engine $INSTALL_TARGET/www
604        if [ ! -d "$INSTALL_TARGET/www/html" ]; then
605                errorAndLog "${FUNCNAME}(): unable to create Doxygen web files."
606                return 1
607        fi
608        rm -fr "$INSTALL_TARGET/www/api"
609        mv "$INSTALL_TARGET/www/html" "$INSTALL_TARGET/www/api"
610        rm -fr $INSTALL_TARGET/www/{man,perlmod,rtf}
611        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/www/api
612        echoAndLog "${FUNCNAME}(): Doxygen web files created successfully."
613}
614
615
616# Crea la estructura base de la instalación de opengnsys
617function createDirs()
618{
619        # Crear estructura de directorios.
620        echoAndLog "${FUNCNAME}(): creating directory paths in ${INSTALL_TARGET}"
621        local dir
622
623        mkdir -p ${INSTALL_TARGET}/{bin,doc,etc,lib,sbin,www}
624        mkdir -p ${INSTALL_TARGET}/{client,images}
625        mkdir -p ${INSTALL_TARGET}/log/clients
626        ln -fs ${INSTALL_TARGET}/log /var/log/opengnsys
627        # Detectar directorio de instalación de TFTP.
628        if [ ! -L ${INSTALL_TARGET}/tftpboot ]; then
629                for dir in /var/lib/tftpboot /srv/tftp; do
630                        [ -d $dir ] && ln -fs $dir ${INSTALL_TARGET}/tftpboot
631                done
632        fi
633        mkdir -p ${INSTALL_TARGET}/tftpboot/menu.lst
634        if [ $? -ne 0 ]; then
635                errorAndLog "${FUNCNAME}(): error while creating dirs. Do you have write permissions?"
636                return 1
637        fi
638
639        # Crear usuario ficticio.
640        if id -u $OPENGNSYS_CLIENTUSER &>/dev/null; then
641                echoAndLog "${FUNCNAME}(): user \"$OPENGNSYS_CLIENTUSER\" is already created"
642        else
643                echoAndLog "${FUNCNAME}(): creating OpenGnsys user"
644                useradd $OPENGNSYS_CLIENTUSER 2>/dev/null
645                if [ $? -ne 0 ]; then
646                        errorAndLog "${FUNCNAME}(): error creating OpenGnsys user"
647                        return 1
648                fi
649        fi
650
651        # Establecer los permisos básicos.
652        echoAndLog "${FUNCNAME}(): setting directory permissions"
653        chmod -R 775 $INSTALL_TARGET/{log/clients,images,tftpboot/menu.lst}
654        mkdir -p $INSTALL_TARGET/tftpboot/menu.lst/examples
655        ! [ -f $INSTALL_TARGET/tftpboot/menu.lst/templates/00unknown ] && mv $INSTALL_TARGET/tftpboot/menu.lst/templates/* $INSTALL_TARGET/tftpboot/menu.lst/examples
656        chown -R :$OPENGNSYS_CLIENTUSER $INSTALL_TARGET/{log/clients,images,tftpboot/menu.lst}
657        if [ $? -ne 0 ]; then
658                errorAndLog "${FUNCNAME}(): error while setting permissions"
659                return 1
660        fi
661
662        # Mover el fichero de registro al directorio de logs.
663        echoAndLog "${FUNCNAME}(): moving update log file"
664        mv $LOG_FILE $OGLOGFILE && LOG_FILE=$OGLOGFILE
665        chmod 600 $LOG_FILE
666
667        echoAndLog "${FUNCNAME}(): directory paths created"
668        return 0
669}
670
671# Actualización incremental de la BD (versión actaul a actaul+1, hasta final-1 a final).
672function updateDatabase()
673{
674        local OLDVERSION=$(awk '{print $2}' $INSTALL_TARGET/doc/VERSION.txt)
675        local NEWVERSION=$(awk '{print $2}' $WORKDIR/opengnsys/doc/VERSION.txt)
676        local DBDIR="$WORKDIR/opengnsys/admin/Database"
677        local file FILES=""
678
679        echoAndLog "${FUNCNAME}(): looking for database updates"
680        pushd $DBDIR >/dev/null
681        # Bucle de actualización incremental desde versión actual a la final.
682        for file in $OPENGNSYS_DATABASE-*-*.sql; do
683                case "$file" in
684                        $OPENGNSYS_DATABASE-$OLDVERSION-$NEWVERSION.sql)
685                                # Actualización única de versión inicial y final.
686                                FILES="$FILES $file"
687                                break
688                                ;;
689                        $OPENGNSYS_DATABASE-*-postinst.sql)
690                                # Ignorar fichero específico de post-instalación.
691                                ;;
692                        $OPENGNSYS_DATABASE-$OLDVERSION-*.sql)
693                                # Actualización de versión n a n+1.
694                                FILES="$FILES $file"
695                                OLDVERSION="$(echo $file | cut -f3 -d-)"
696                                ;;
697                        $OPENGNSYS_DATABASE-*-$NEWVERSION.sql)
698                                # Última actualización de versión final-1 a final.
699                                if [ -n "$FILES" ]; then
700                                        FILES="$FILES $file"
701                                        break
702                                fi
703                                ;;
704                esac
705        done
706        # Aplicar posible actualización propia para la versión final.
707        file=$OPENGNSYS_DATABASE-$NEWVERSION.sql
708        if [ -n "$FILES" -o "$OLDVERSION" = "$NEWVERSION" -a -r $file ]; then
709                FILES="$FILES $file"
710        fi
711
712        popd >/dev/null
713        if [ -n "$FILES" ]; then
714                for file in $FILES; do
715                        importSqlFile $OPENGNSYS_DBUSER $OPENGNSYS_DBPASSWORD $OPENGNSYS_DATABASE $DBDIR/$file
716                done
717                echoAndLog "${FUNCNAME}(): database is update"
718        else
719                echoAndLog "${FUNCNAME}(): database unchanged"
720        fi
721}
722
723# Copia ficheros de configuración y ejecutables genéricos del servidor.
724function updateServerFiles()
725{
726        # No copiar ficheros del antiguo cliente Initrd
727        local SOURCES=( repoman/bin \
728                        server/bin \
729                        server/lib \
730                        admin/Sources/Services/ogAdmServerAux \
731                        admin/Sources/Services/ogAdmRepoAux \
732                        server/tftpboot \
733                        installer/opengnsys_uninstall.sh \
734                        installer/opengnsys_export.sh \
735                        installer/opengnsys_import.sh \
736                        doc )
737        local TARGETS=( bin \
738                        bin \
739                        lib \
740                        sbin/ogAdmServerAux \
741                        sbin/ogAdmRepoAux \
742                        tftpboot \
743                        lib/opengnsys_uninstall.sh \
744                        lib/opengnsys_export.sh \
745                        lib/opengnsys_import.sh \
746                        doc )
747
748        if [ ${#SOURCES[@]} != ${#TARGETS[@]} ]; then
749                errorAndLog "${FUNCNAME}(): inconsistent number of array items"
750                exit 1
751        fi
752
753        echoAndLog "${FUNCNAME}(): updating files in server directories"
754        pushd $WORKDIR/opengnsys >/dev/null
755        local i
756        for (( i = 0; i < ${#SOURCES[@]}; i++ )); do
757                if [ -d "$INSTALL_TARGET/${TARGETS[i]}" ]; then
758                        rsync --exclude .svn -irplt "${SOURCES[i]}" $(dirname $(readlink -e "$INSTALL_TARGET/${TARGETS[i]}"))
759                else
760                        rsync -irplt "${SOURCES[i]}" $(readlink -m "$INSTALL_TARGET/${TARGETS[i]}")
761                fi
762        done
763        popd >/dev/null
764        NEWFILES=""             # Ficheros de configuración que han cambiado de formato.
765        if grep -q 'pxelinux.0' /etc/dhcp*/dhcpd*.conf; then
766                echoAndLog "${FUNCNAME}(): updating DHCP files"
767                perl -pi -e 's/pxelinux.0/grldr/' /etc/dhcp*/dhcpd*.conf
768                $DHCPSERV restart
769                NEWFILES="/etc/dhcp*/dhcpd*.conf"
770        fi
771        if ! diff -q $WORKDIR/opengnsys/admin/Sources/Services/opengnsys.init /etc/init.d/opengnsys 2>/dev/null; then
772                echoAndLog "${FUNCNAME}(): updating new init file"
773                backupFile /etc/init.d/opengnsys
774                cp -a $WORKDIR/opengnsys/admin/Sources/Services/opengnsys.init /etc/init.d/opengnsys
775                NEWFILES="$NEWFILES /etc/init.d/opengnsys"
776        fi
777        if egrep -q "(UrlMsg=.*msgbrowser.php)|(UrlMenu=http://)" $INSTALL_TARGET/client/etc/ogAdmClient.cfg 2>/dev/null; then
778                echoAndLog "${FUNCNAME}(): updating new client config file"
779                backupFile $INSTALL_TARGET/client/etc/ogAdmClient.cfg
780                perl -pi -e 's!UrlMsg=.*msgbrowser\.php!UrlMsg=http://localhost/cgi-bin/httpd-log\.sh!g; s!UrlMenu=http://!UrlMenu=https://!g' $INSTALL_TARGET/client/etc/ogAdmClient.cfg
781                NEWFILES="$NEWFILES $INSTALL_TARGET/client/etc/ogAdmClient.cfg"
782        fi
783
784        echoAndLog "${FUNCNAME}(): updating cron files"
785        [ ! -f /etc/cron.d/opengnsys ] && echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/opengnsys.cron ] && $INSTALL_TARGET/bin/opengnsys.cron" > /etc/cron.d/opengnsys
786        [ ! -f /etc/cron.d/torrentcreator ] && echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/torrent-creator ] && $INSTALL_TARGET/bin/torrent-creator" > /etc/cron.d/torrentcreator
787        [ ! -f /etc/cron.d/torrenttracker ] && echo "5 * * * *   root   [ -x $INSTALL_TARGET/bin/torrent-tracker ] && $INSTALL_TARGET/bin/torrent-tracker" > /etc/cron.d/torrenttracker
788        [ ! -f /etc/cron.d/imagedelete ] && echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/deletepreimage ] && $INSTALL_TARGET/bin/deletepreimage" > /etc/cron.d/imagedelete
789        echoAndLog "${FUNCNAME}(): server files updated successfully."
790}
791
792####################################################################
793### Funciones de compilación de código fuente de servicios
794####################################################################
795
796# Mueve el fichero del nuevo servicio si es distinto al del directorio destino.
797function moveNewService()
798{
799        local service
800
801        # Recibe 2 parámetros: fichero origen y directorio destino.
802        [ $# == 2 ] || return 1
803        [ -f  $1 -a -d $2 ] || return 1
804
805        # Comparar los ficheros.
806        if ! diff -q $1 $2/$(basename $1) &>/dev/null; then
807                # Parar los servicios si fuese necesario.
808                [ -z "$NEWSERVICES" ] && service="opengnsys" $STOPSERVICE
809                # Nuevo servicio.
810                NEWSERVICES="$NEWSERVICES $(basename $1)"
811                # Mover el nuevo fichero de servicio
812                mv $1 $2
813        fi
814}
815
816
817# Recompilar y actualiza los serivicios y clientes.
818function compileServices()
819{
820        local hayErrores=0
821
822        # Compilar OpenGnsys Server
823        echoAndLog "${FUNCNAME}(): Recompiling OpenGnsys Admin Server"
824        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmServer
825        make && moveNewService ogAdmServer $INSTALL_TARGET/sbin
826        if [ $? -ne 0 ]; then
827                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Admin Server"
828                hayErrores=1
829        fi
830        popd
831        # Compilar OpenGnsys Repository Manager
832        echoAndLog "${FUNCNAME}(): Recompiling OpenGnsys Repository Manager"
833        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmRepo
834        make && moveNewService ogAdmRepo $INSTALL_TARGET/sbin
835        if [ $? -ne 0 ]; then
836                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Repository Manager"
837                hayErrores=1
838        fi
839        popd
840        # Actualizar o insertar clave de acceso REST en el fichero de configuración del repositorio.
841        grep -q '^ApiToken=' $INSTALL_TARGET/etc/ogAdmRepo.cfg && \
842                sed -i "s/^ApiToken=.*$/ApiToken=$REPOKEY/" $INSTALL_TARGET/etc/ogAdmRepo.cfg || \
843                sed -i "$ a\ApiToken=$REPOKEY/" $INSTALL_TARGET/etc/ogAdmRepo.cfg
844        # Compilar OpenGnsys Agent
845        echoAndLog "${FUNCNAME}(): Recompiling OpenGnsys Agent"
846        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmAgent
847        make && moveNewService ogAdmAgent $INSTALL_TARGET/sbin
848        if [ $? -ne 0 ]; then
849                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Agent"
850                hayErrores=1
851        fi
852        popd
853
854        # Compilar OpenGnsys Client
855        echoAndLog "${FUNCNAME}(): Recompiling OpenGnsys Client"
856        pushd $WORKDIR/opengnsys/admin/Sources/Clients/ogAdmClient
857        make && mv ogAdmClient $INSTALL_TARGET/client/bin
858        if [ $? -ne 0 ]; then
859                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Client"
860                hayErrores=1
861        fi
862        popd
863
864        return $hayErrores
865}
866
867
868####################################################################
869### Funciones instalacion cliente OpenGnsys
870####################################################################
871
872# Actualizar cliente OpenGnsys
873function updateClient()
874{
875        PATH=$PATH:$INSTALL_TARGET/bin
876        local DOWNLOADURL=$(oglivecli config download-url)
877        #local FILENAME=ogLive-wily-4.2.0-35-generic-r4919.iso          # 1.1.0-rc3
878        local FILENAME=ogLive-xenial-4.4.0-34-generic-r4999.iso         # 1.1.0-rc4
879        local SOURCEFILE=$DOWNLOADURL/$FILENAME
880        local TARGETFILE=$(oglivecli config download-dir)/$FILENAME
881        local SOURCELENGTH
882        local TARGETLENGTH
883        local OGINITRD
884        local SAMBAPASS
885        local KERNELVERSION
886
887        # Comprobar si debe convertirse el antiguo cliente al nuevo formato ogLive.
888        if oglivecli check | grep -q "oglivecli convert"; then
889                echoAndLog "${FUNCNAME}(): Converting OpenGnsys Client to default ogLive"
890                oglivecli convert
891        fi
892        # Comprobar si debe actualizarse el cliente.
893        SOURCELENGTH=$(LANG=C wget --spider $SOURCEFILE 2>&1 | awk '/Length:/ {print $2}')
894        TARGETLENGTH=$(stat -c "%s" $TARGETFILE 2>/dev/null)
895        [ -z $TARGETLENGTH ] && TARGETLENGTH=0
896        if [ "$SOURCELENGTH" != "$TARGETLENGTH" ]; then
897                echoAndLog "${FUNCNAME}(): Downloading ogLive"
898                oglivecli download $FILENAME
899                if [ ! -s $TARGETFILE ]; then
900                        errorAndLog "${FUNCNAME}(): Error loading OpenGnsys Client"
901                        return 1
902                fi
903                # Actaulizar la imagen ISO del ogclient.
904                echoAndLog "${FUNCNAME}(): Updatting ogLive"
905                oglivecli install $FILENAME
906               
907                # Obtiene versión del Kernel del cliente (con 2 decimales).
908                KERNELVERSION=$(jq -r ".oglive[.default].kernel" |
909                                awk -F. '{printf("%d",$1); $1=""; printf(".%02d",$0)}')
910                # Actaulizar la base de datos adaptada al Kernel del cliente.
911                OPENGNSYS_DBUPDATEFILE="$WORKDIR/opengnsys/admin/Database/$OPENGNSYS_DATABASE-$INSTVERSION-postinst.sql"
912                if [ -f $OPENGNSYS_DBUPDATEFILE ]; then
913                        perl -pi -e "s/KERNELVERSION/$KERNELVERSION/g" $OPENGNSYS_DBUPDATEFILE
914                        importSqlFile $OPENGNSYS_DBUSER $OPENGNSYS_DBPASSWORD $OPENGNSYS_DATABASE $OPENGNSYS_DBUPDATEFILE
915                fi
916                CLIENTUPDATED=${FILENAME%.*}
917
918                echoAndLog "${FUNCNAME}(): Client update successfully"
919        else
920                # Si no existe, crear el fichero de claves de Rsync.
921                if [ ! -f /etc/rsyncd.secrets ]; then
922                        echoAndLog "${FUNCNAME}(): Restoring client access key"
923                        OGINITRD=$(oglivecli config install-dir)/$(jq -r ".oglive[.default].directory")/oginitrd.img
924                        SAMBAPASS=$(gzip -dc $OGINITRD | \
925                                    cpio -i --to-stdout scripts/ogfunctions 2>&1 | \
926                                    grep "^[    ].*OPTIONS=" | \
927                                    sed 's/\(.*\)pass=\(\w*\)\(.*\)/\2/')
928                        echo -ne "$SAMBAPASS\n$SAMBAPASS\n" | setsmbpass
929                else
930                        echoAndLog "${FUNCNAME}(): Client is already updated"
931                fi
932                # Versión del ogLive instalado.
933                echo "${FILENAME%.*}" > $INSTALL_TARGET/doc/veroglive.txt
934        fi
935}
936
937# Comprobar permisos y ficheros.
938function checkFiles()
939{
940        # Comprobar permisos adecuados.
941        if [ -x $INSTALL_TARGET/bin/checkperms ]; then
942                echoAndLog "${FUNCNAME}(): Checking permissions."
943                OPENGNSYS_DIR="$INSTALL_TARGET" OPENGNSYS_USER="$OPENGNSYS_CLIENTUSER" APACHE_USER="$APACHE_RUN_USER" APACHE_GROUP="$APACHE_RUN_GROUP" $INSTALL_TARGET/bin/checkperms
944        fi
945
946        # Eliminamos el fichero de estado del tracker porque es incompatible entre los distintos paquetes
947        if [ -f /tmp/dstate ]; then
948                echoAndLog "${FUNCNAME}(): Delete unused files."
949                rm -f /tmp/dstate
950        fi
951}
952
953# Resumen de actualización.
954function updateSummary()
955{
956        # Actualizar fichero de versión y revisión.
957        local VERSIONFILE="$INSTALL_TARGET/doc/VERSION.txt"
958        local REVISION=$(LANG=C svn info $SVN_URL|awk '/Rev:/ {print "r"$4}')
959
960        [ -f $VERSIONFILE ] || echo "OpenGnsys" >$VERSIONFILE
961        perl -pi -e "s/($| r[0-9]*)/ $REVISION/" $VERSIONFILE
962
963        echo
964        echoAndLog "OpenGnsys Update Summary"
965        echo       "========================"
966        echoAndLog "Project version:                  $(cat $VERSIONFILE)"
967        echoAndLog "Update log file:                  $LOG_FILE"
968        if [ -n "$NEWFILES" ]; then
969                echoAndLog "Check new config files:           $(echo $NEWFILES)"
970        fi
971        if [ -n "$NEWSERVICES" ]; then
972                echoAndLog "New compiled services:            $(echo $NEWSERVICES)"
973                # Indicar si se debe reiniciar servicios manualmente o usando el Cron.
974                [ -f /etc/default/opengnsys ] && source /etc/default/opengnsys
975                if [ "$RUN_CRONJOB" == "no" ]; then
976                        echoAndLog "        WARNING: you must restart OpenGnsys services manually."
977                else
978                        echoAndLog "        New OpenGnsys services will be restarted by the cronjob."
979                fi
980        fi
981        echoAndLog "Warnings:"
982        echoAndLog " - You must to clear web browser cache before loading OpenGnSys page."
983        if [ -n "$CLIENTUPDATED" ]; then
984                echoAndLog " - ogLive Client is updated to: $CLIENTUPDATED"
985        fi
986        echo
987}
988
989
990
991#####################################################################
992####### Proceso de actualización de OpenGnsys
993#####################################################################
994
995
996echoAndLog "OpenGnsys update begins at $(date)"
997
998pushd $WORKDIR
999
1000# Comprobar si hay conexión y detectar parámetros de red por defecto.
1001checkNetworkConnection
1002if [ $? -ne 0 ]; then
1003        errorAndLog "Error connecting to server. Causes:"
1004        errorAndLog " - Network is unreachable, review devices parameters."
1005        errorAndLog " - You are inside a private network, configure the proxy service."
1006        errorAndLog " - Server is temporally down, try agian later."
1007        exit 1
1008fi
1009getNetworkSettings
1010
1011# Comprobar auto-actualización del programa.
1012if [ "$PROGRAMDIR" != "$INSTALL_TARGET/bin" ]; then
1013        checkAutoUpdate
1014        if [ $? -ne 0 ]; then
1015                echoAndLog "OpenGnsys updater has been overwritten."
1016                echoAndLog "Please, re-execute this script."
1017                exit
1018        fi
1019fi
1020
1021# Detectar datos de auto-configuración del instalador.
1022autoConfigure
1023
1024# Instalar dependencias.
1025installDependencies ${DEPENDENCIES[*]}
1026if [ $? -ne 0 ]; then
1027        errorAndLog "Error: you may install all needed dependencies."
1028        exit 1
1029fi
1030
1031# Arbol de directorios de OpenGnsys.
1032createDirs ${INSTALL_TARGET}
1033if [ $? -ne 0 ]; then
1034        errorAndLog "Error while creating directory paths!"
1035        exit 1
1036fi
1037
1038# Si es necesario, descarga el repositorio de código en directorio temporal
1039if [ $USESVN -eq 1 ]; then
1040        svnExportCode $SVN_URL
1041        if [ $? -ne 0 ]; then
1042                errorAndLog "Error while getting code from svn"
1043                exit 1
1044        fi
1045else
1046        ln -fs "$(dirname $PROGRAMDIR)" opengnsys
1047fi
1048
1049# Actualizar la BD.
1050updateDatabase
1051
1052# Actualizar ficheros complementarios del servidor
1053updateServerFiles
1054if [ $? -ne 0 ]; then
1055        errorAndLog "Error updating OpenGnsys Server files"
1056        exit 1
1057fi
1058
1059# Configurar Rsync.
1060rsyncConfigure
1061
1062# Actualizar ficheros del cliente
1063updateClientFiles
1064updateInterfaceAdm
1065
1066# Actualizar páqinas web
1067apacheConfiguration
1068updateWebFiles
1069if [ $? -ne 0 ]; then
1070        errorAndLog "Error updating OpenGnsys Web Admin files"
1071        exit 1
1072fi
1073# Generar páginas Doxygen para instalar en el web
1074makeDoxygenFiles
1075
1076# Recompilar y actualizar los servicios del sistema
1077compileServices
1078
1079# Actaulizar ficheros auxiliares del cliente
1080updateClient
1081if [ $? -ne 0 ]; then
1082        errorAndLog "Error updating clients"
1083        exit 1
1084fi
1085
1086# Comprobar permisos y ficheros.
1087checkFiles
1088
1089# Mostrar resumen de actualización.
1090updateSummary
1091
1092#rm -rf $WORKDIR
1093echoAndLog "OpenGnsys update finished at $(date)"
1094
1095popd
1096
Note: See TracBrowser for help on using the repository browser.